// Fabien HENON * 1997
// 100 % CSG objects
// 			The pen was my actual pen
// 			The lilghter is from the internet
// to render with povray 3.0 -> 3.7

camera {
    location <40, 100, -100>
   direction <0, 0, 1.6>
         sky <0, 1, 0>
          up <0, 1, 0>
       right <1.33333, 0, 0>
//     look_at <-50,0,40>
     look_at <-30, 36, 0>
}


#default { texture { finish { ambient 0.3 }}}

#declare M_Wood8A =
color_map {
    [0.0, 0.1 color rgb <0.45, 0.30, 0.15>
              color rgb <0.45, 0.30, 0.15>]
    [0.1, 0.9 color rgb <0.55, 0.30, 0.15>
              color rgb <0.20, 0.15, 0.05>]
    [0.9, 1.0 color rgb <0.20, 0.15, 0.05>
              color rgb <0.45, 0.30, 0.15>]
}
#declare M_Wood8B =
color_map {
    [0.0, 0.5 color rgbf <0.60, 0.35, 0.20, 0.30>
              color rgbf <0.60, 0.35, 0.20, 0.80>]
    [0.5, 1.0 color rgbf <0.60, 0.35, 0.20, 0.80>
              color rgbf <1.00, 1.00, 1.00, 1.00> ]
}

#declare P_WoodGrain1A =
pigment {
    wood
    turbulence 0.04
    octaves 3
    scale <0.05, .05, 1>
}

#declare P_WoodGrain1B =
pigment {
    wood
    turbulence <0.1, 0.5, 1>
    octaves 5
    lambda 3.25
    scale <0.15, .5, 1>
    rotate <5, 10, 5>
    translate -x*2
}

#declare Test8 =
    texture { pigment { P_WoodGrain1A color_map { M_Wood8A }}
    normal {
    wood 0.3
    turbulence 0.04
    octaves 3
    scale <0.05, .05, 1> }}

    texture { pigment { P_WoodGrain1B color_map { M_Wood8B }}
    normal {
    wood 0.3
    turbulence <0.1, 0.5, 1>
    octaves 5
    lambda 3.25
    scale <0.15, .5, 1>
    rotate <5, 10, 5>
    translate -x*2
    }
  pigment { warp { 
  black_hole <0,0,0>,10 
  } 
  }
    
    }

global_settings {
radiosity {

brightness 6
count 200
distance_maximum 0.8
error_bound 0.33
gray_threshold 0.6
nearest_count 7
low_error_factor 0.6}
#max_trace_level 15
#max_intersections 100 }

    light_source {  <300, 200, -300>
        color rgb<1, 1, 0.98>

        area_light <20, 17, 30>, <15, -2, 15>, 4, 4  adaptive 1
        }

    light_source {  <300, 200, -300>
        color rgb<1, 1, 0.98>

        area_light <20, 17, 30>, <15, -2, 15>, 4, 4  adaptive 1
        }

plane { y,0
  texture { Test8 
  scale 65
finish { ambient 0.3}
}
}


#declare Metal =
 finish
  {metallic
   ambient 0.2
   diffuse 0.7
   brilliance 6
   reflection 0.25
   phong 0.75
   phong_size 80
  }

#declare SilverFinish = finish {
    metallic
    ambient 0.25
    diffuse 0.65
    reflection 0.45
    brilliance 6
    phong 0.4
    phong_size 100
}


#declare roulette=
texture {
pigment {color  red 0.4 green 0.4 blue 0.45}
finish {Metal reflection 0.1}
}

#declare Silver1_Colour = color  red 0.94 green 0.93 blue 0.83

#declare Silver1 = texture {
    pigment { Silver1_Colour }
    finish { SilverFinish }
}
#declare Or=texture { pigment { color red 0.85 green 0.85 blue 0.10 }
finish { Metal}}

#include "pen.inc"

background { color rgb <0.1,0.5,0.7>}
global_settings {
#max_trace_level 5
#max_intersections 100
                 }

#include "papier.inc"

object { feuille
pigment { image_map { tga "vaucher1.tga" interpolate 2 }}
finish { ambient 0.3 }
scale <190,320,150>
rotate <90,0,0>
rotate <0,-40,0>
translate <-130,0.0001,-70>
}


////////////////////////DEFINITION DES CRANS//////////////////////

#declare cran=
difference {
object {
box {<0,0,0>,<2.3,2.3,2> rotate <0,0,45>} scale <0.7,1,1>}
cone {<0,0,-1>,3,<0,0,3>,3}
texture {roulette }
bounded_by {box {<-1,2.7,0>,<1,3.57,2>}}
}

#declare allumage=union {
#declare co=0
#while (co<=360)
object {cran
rotate <0,0,co>
translate <2,75,-4.5>}
object {cran
rotate <0,0,co>
translate <2,75,2.5>}
#declare co=co+10
#end

//////////////////////ROULETTES////////////////////////

difference {
cone {<2,75,-4.5>,3,<2,75,-2.5>,3 }
cone {<2,75,-4.51>,2.7,<2,75,-3>,2.7}
texture { roulette}
bounded_by { box { <-1,72,-4.5>,<5,78,-2.5>}}
}
difference {
cone {<2,75,4.5>,3,<2,75,2.5>,3}
cone {<2,75,4.51>,2.7,<2,75,3>,2.7}
texture { roulette}
bounded_by { box { <-1,72,2.5>,<5,78,4.5>}}
}
cone {<2,75,-2.5>,2.5,<2,75,2.5>,2.5
texture { pigment { color rgb <0.5,0.4,0.45>}
normal { gradient y+z scale 0.1}
finish {metallic
   ambient 0.2
   diffuse 0.7
   brilliance 6
   reflection 0
   phong 0.2
   phong_size 80
  }
}}
cone {<2,69,0>,2,<2,72,0>,2
pigment { color rgb <0.3,0.3,0.4>}}
}

/////////////////////////CORPS DU BRIQUET///////////////////////

#declare tronc=
intersection {  // Layer name: Untitled

    cone { <0, 0, 0>, 16.25, <0, 67, 0>, 16.25 scale <1, 1, 0.4> }

    cone { <0, 0, 0>, 32.8, <0, 66, 0>, 32.8 scale <0.35, 1, 1> }

    cone { <0, 0, 0>, 12.1 <0, 66.001, 0>, 12.1 scale <1, 1, 0.9>}

bounded_by { box { <-12,0,-7>,<12,66,7>}}
}

#declare corps=
difference { object { tronc }
box { <-10,-0.001,-4>,<10,66.001,4> }
pigment { 
gradient y
color_map { 
[ 0 color rgb <0.02,0.79,0.85>]
[ 1 color rgb <0,0.4,0.9> ] }
scale <1,66.5,1> }
finish { specular 0.4 roughness 0.04}
bounded_by { box {<-23,0,-13>,<23,66,13>}}
}

#declare mat=
intersection {  // Layer name: Untitled
    cone { <0, 66, 0>, 16.25, <0, 77, 0>, 16.25 scale <1, 1, 0.4> }

    cone { <0, 66, 0>, 32.8, <0, 78, 0>, 32.8 scale <0.35, 1, 1> }

    cone { <0, 66, 0>, 12.1, <0, 79, 0>, 12.1 scale <1, 1, 0.9> }
         bounded_by { box {<-11.48,66,-6.5>,<11.48,77,6.5>}}
         }

#declare anti=
intersection {  // Layer name: Untitled
    cone { <0, 66, 0>, 16.25, <0, 77, 0>, 16.25 scale <1, 1, 0.4> }

    cone { <0, 66, 0>, 32.8, <0, 78, 0>, 32.8 scale <0.35, 1, 1> }

    cone { <0, 66, 0>, 12.1, <0, 79, 0>, 12.1 scale <1, 1, 0.9> }
    scale <0.85,1.0001,0.85>
         bounded_by { box {<-11.48,66,-6.5>,<11.48,77,6.5>}}
         }

////////////////////////////////PARAVENT///////////////////////////////

#declare embout=
difference {
object { mat }
union {
object { anti }
plane { x,4 inverse }}
bounded_by { box {<-11.48,66,-6.5>,<4,77,6.5>}}
texture { Silver1}
}

////////////////ARRONDIR LES ANGLES DU PARAVENT////////////////////////

#declare formeronde=
intersection {  union {
object { torus { 16.25, 0.861 } scale <1, 1, 0.4>  inverse}
object { torus { 32.8 , 0.861 } scale <0.35, 1, 1> inverse}
object { torus { 12.1 , 0.861 } scale <1, 1, 0.9>  inverse}
         translate <0,76.139,0>

         }
object {embout scale <1.08823,1,1.08823> translate < 0,10.139,0>}
texture { Silver1}
bounded_by { box {<-11.45,73,-6.5>,<4,78,6.5>}}
}

#declare coinrond=
intersection {
cone { <2,75,-6.55>,2,<2,75,6.55>,2 inverse}
box { <2,75,-6.55>,<4,77,6.55> scale 1.0001}
bounded_by { box {<2,75,-6.55>,<4,77,6.5>}}
texture { Silver1}
}

#declare pare=
difference{ object {embout }
object { coinrond }
bounded_by { box {<-11.48,66,-6.5>,<4,77,6.5>}}
texture {Silver1}
}

#declare pare_vent=difference {
object { pare }
object { formeronde}}

///////////////////////////////GACHETTE////////////////////////////////

#declare gachette=
union {
box{<-3,60,-3.5>,<9.5,69,3.5> }
difference {
intersection {  // Layer name: Untitled

    cone { <0, 69, 0>, 16.25, <0, 71.001, 0>, 16.25 scale <1, 1, 0.4> }

    cone { <0, 69, 0>, 32.8, <0, 71, 0>, 32.8 scale <0.35, 1, 1> }

    cone { <0, 69, 0>, 12.1, <0, 71.00001, 0>, 12.1 scale <1, 1, 0.9> }
         }
union {
object {
box { <0,0,0>,<5,23,13>} rotate <0,0,94> translate <11.48,71,-6.5> }
box {<-11.48,68.99,-6.5>,<4.5,71.1,6.5>} }
bounded_by { box { <4.4,69,-6.5>,<11.5,71,6.5>}}
}
box {<0,69,-3.5>,<4.5,71,3.5> pigment { color rgb <0.7,0.7,0.5>}}
pigment { color rgb <0.1,0.1,0.1>}
finish { phong 0.3 phong_size 100}
}

///////////////////////INSCRIPTION 'FIRE' DANS LE METAL//////////////////////

#declare inscription=
difference {
object {
height_field {
gif "fire.gif"
water_level 0.01 }
bounded_by {box{ <0,0,0>,<1,1,1>}}
scale <12,12,10>
rotate <-90,0,0>
translate <-9,66,-6.3>
}
union {
cone { <0, 66, 0>, 16.25, <0, 77.001, 0>, 16.25 scale <1, 1, 0.4>
translate <0,0,-0.6> }

cone { <0, 66, 0>, 16.25, <0, 77.001, 0>, 16.25 scale <1, 1, 0.4>
translate <0,0,-1.0001> inverse} }
texture { Or }
}

#declare briquet=union {
object { corps }
object { gachette translate <0,1,0>}
difference { object { pare_vent} object { inscription translate <0,0,1>}}
object { allumage}
            }

object { briquet rotate <0,10,0>}

object {stylo rotate <0,110,0> translate <-120,0,30>}
object { capuchon rotate <0,-30,0> translate <-40,0,20>}
  
